/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                       *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#define USE_SCIM_KDE_SETTINGS
#include "inputwindow.h"

#include <qlineedit.h>
// #include <qtooltip.h>
// #include <qwhatsthis.h>

#include "scimlookuptable.h"
#include "scimlineedit.h"
#include "scimdragableframe.h"
#include "src/scimglobalactions.h"

// #define SKIM_CONFIG_GROUP "InputWindow"
// #define SCIM_CONFIG_PANEL_KDE_LOOKUP_TABLE_VERTICAL    "/Panel/KDE/InputWindow/LookupTableVertical"
#define MODULE_UUID "a1d34730-6d08-4f59-a418-e63334a46538"
#define TOP_LEVEL_WFLAGS \
   Qt::WStyle_Customize|Qt::WStyle_NoBorder|Qt::WStyle_StaysOnTop|Qt::WX11BypassWM|Qt::WStyle_Tool
extern "C" {
    static inputWindow* _inputwindow_widget = 0;
    QWidget* init( ModulesCollection* is, ModuleDefinition& md, QWidget* /*preferedParent*/)
    {
        if( md.uuid == MODULE_UUID )
        {
            _inputwindow_widget = new inputWindow(is, 0,0, TOP_LEVEL_WFLAGS);
            return _inputwindow_widget;
        }
        return 0;
    }
    bool getInfo( ModulesCollection * , ModuleDefinition* md)
    {
        md->uuid = MODULE_UUID;
        md->type = scim_kde::GeneralModule;
        md->load_type = scim_kde::Permanent;
        md->name = i18n("Input Window");
        md->comment = i18n("When inputing CJK, you will interact with this window.");

        return true;
    }
    bool isFinished()
    {
        return !_inputwindow_widget;
    }
}

inputWindow::inputWindow( ModulesCollection* is, QWidget* parent, const char* name, WFlags fl )
    : ScimDragableFrame( parent, parent, name, fl )
    ,OriginalX( 0 ), OriginalY( 0 )
{
    //LookupTableIsVertical = true;
    allModules = is;
    InputServer = allModules->getInputServer();
//     Config = allModules->getConfig();
//     Config->setGroup(SKIM_CONFIG_GROUP);

    LookupTableIsVertical = ScimKdeSettings::lookupTable_IsVertical();
    ScreenRect = QApplication::desktop()->screenGeometry();
    if ( !name )
      setName( "inputWindow" );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)1, 0, 0) );
    inputWindowLayout = new QVBoxLayout( this, 3, 1, "inputWindowLayout");
    inputWindowLayout->setResizeMode( QLayout::FreeResize );

    PreEditText = new ScimLineEdit( this, "PreEditText" );
    PreEditText->hide();
    PreEditText->setBackgroundOrigin( QLineEdit::AncestorOrigin );
    PreEditText->setMouseTracking( FALSE );
    PreEditText->setAcceptDrops( FALSE );
    inputWindowLayout->addWidget( PreEditText );
    
    AuxText = new QLabel(this);
    AuxText->setFrameShape( QFrame::Box );
    AuxText->setFrameShadow( QFrame::Raised );
    inputWindowLayout->addWidget( AuxText );
    AuxText->hide();

    LookupLbl = new ScimLookupTable( this, inputWindowLayout, "LookupLbl", LookupTableIsVertical);
    LookupLbl->setEnableHighlight(ScimKdeSettings::highlight_Candidate());
// //     QWidget *p = parentWidget() ? parentWidget() : topLevelWidget();
//     LookupLbl->reparent(0,TOP_LEVEL_WFLAGS, LookupLbl->geometry().topLeft(),true);
//     LookupLbl->show();
//     LookupLbl->adjustSize();
    inputWindowLayout->addWidget( LookupLbl );
    
    languageChange();
    clearWState( WState_Polished );

    // signals and slots connections
    connect( LookupLbl, SIGNAL( previousPageRequested() ), InputServer, SLOT( lookupTablePageUp() ) );
    connect( LookupLbl, SIGNAL( nextPageRequested() ), InputServer, SLOT( lookupTablePageDown() ) );

    connect( InputServer, SIGNAL( updatePreeditStringReq( QString, scim::AttributeList ) ),
        this, SLOT( updatePreeditString( QString, scim::AttributeList ) ) );
    connect( InputServer, SIGNAL( updateLookupTableReq( QStringList, bool, bool ) ),
        this, SLOT( updateLookupTable( QStringList, bool, bool ) ) );
    connect( InputServer, SIGNAL( updateAuxStringReq(QString, scim::AttributeList ) ),
        this, SLOT(updateAuxString(QString, scim::AttributeList ) ) );
        
    connect( InputServer, SIGNAL( showAuxStringReq() ), this, SLOT( showAuxString() ) );
    connect( InputServer, SIGNAL( hideAuxStringReq() ), this, SLOT( hideAuxString() ) );
    connect( InputServer, SIGNAL( showLookupTableReq() ), this, SLOT( showLookupTable() ) );
    connect( InputServer, SIGNAL( showPreeditStringReq() ), this, SLOT( showPreeditString() ) );
    connect( InputServer, SIGNAL( hidePreeditStringReq() ), this, SLOT( hidePreeditString() ) );
    connect( InputServer, SIGNAL( hideLookupTableReq() ),
        this, SLOT( hideLookupTable() ) );
    connect( InputServer, SIGNAL( updateSpotLocationReq( int, int ) ),
        this, SLOT( updateSpotLocation( int, int ) ) );
    connect( InputServer, SIGNAL(updatePreeditCaretReq(int ) ),
        PreEditText, SLOT(setCursorPosition ( int )));
//     connect( InputServer, SIGNAL( turnOnPanelReq() ), this, SLOT( show() ) );
    connect( InputServer, SIGNAL( turnOffPanelReq() ), this, SLOT( hide() ) );

    connect( LookupLbl, SIGNAL(itemSelected(int )), InputServer, SLOT(selectLookupTableItem(int )));
    
    connect( allModules, SIGNAL(settingsChanged()), SLOT(changeSetting()));

    changeSetting();
}

inputWindow::~inputWindow()
{
    _inputwindow_widget = 0;
}
void inputWindow::changeSetting()
{
    LookupLbl->setVertical(ScimKdeSettings::lookupTable_IsVertical());
    if(!ScimKdeSettings::iW_Font().isEmpty())
    {
      QFont customFont;
      customFont.fromString(ScimKdeSettings::iW_Font());
      if(customFont != font())
        setFont(customFont);
    }
    LookupLbl->setEnableHighlight(ScimKdeSettings::highlight_Candidate());
}

void inputWindow::languageChange()
{
    setCaption( tr( "inputWindow" ) );
}

void inputWindow::updateAuxString( QString aux, scim::AttributeList )
{
  AuxText->setText( aux );
}

void inputWindow::showAuxString()
{
  AuxText->show();
  if( !isVisible() )
      show();
  adjustSize();
}

void inputWindow::hideAuxString()
{
  AuxText->hide();
  adjustSize();
}

void inputWindow::updateSpotLocation( int x, int y )
{
    if(sticky) return;

    if( x != OriginalX || y != OriginalY )
    {
        OriginalX = x;
        OriginalY = y;
        if( y + height() > ScreenRect.height() )
            y = ScreenRect.height() - height();
        if( x + width() > ScreenRect.width() )
            x = ScreenRect.width() - width();
        move( x, y );
    }
}
void inputWindow::updatePreeditString( QString newprestr, scim::AttributeList atl)
{
    PreEditText->setTextFormat( atl );
    PreEditText->setText( newprestr );
    adjustSize();
}

void inputWindow::hidePreeditString()
{
    PreEditText->hide();
    adjustSize();
}
void inputWindow::showPreeditString()
{
    PreEditText->show();
    if( !isVisible() )
      show();
    adjustSize();
}
void inputWindow::updateLookupTable( QStringList lookupstringlist, bool preAvailable, bool nextAvailable)
{
    LookupLbl->updateContent(lookupstringlist);
    LookupLbl->enablePreviousPage(preAvailable);
    LookupLbl->enableNextPage(nextAvailable);
    LookupLbl->updateHighlight( 0 );
    adjustSize();
}
void inputWindow::adjustSize()
{
    if(!PreEditText->isVisible() && !LookupLbl->isVisible() && !AuxText->isVisible())
    {
      hide();
      return;
    }
    
    ScimDragableFrame::adjustSize();
}
void inputWindow::hideLookupTable()
{
    LookupLbl->hide();
    adjustSize();
}
void inputWindow::showLookupTable()
{
    LookupLbl->show();
    if( !isVisible() )
      show();
    adjustSize();
}
