/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                       *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef INPUTWINDOW_H
#define INPUTWINDOW_H

#include "src/modulescollection.h"
#include "scimdragableframe.h"

class ScimLineEdit;
class ScimLookupTable;

class QVBoxLayout;
class QHBoxLayout;
class QLabel;

class inputWindow : public ScimDragableFrame
{
    Q_OBJECT

public:
    inputWindow( ModulesCollection*, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~inputWindow();

    ScimLineEdit* PreEditText;
    QLabel* AuxText;
    ScimLookupTable* LookupLbl;

public slots:
    virtual void adjustSize();
    
    virtual void updateAuxString( QString, scim::AttributeList );
    virtual void updateLookupTable( QStringList, bool, bool );
    virtual void updatePreeditString( QString, scim::AttributeList );
    virtual void updateSpotLocation( int, int );
    
    virtual void showAuxString();
    virtual void showLookupTable();
    virtual void showPreeditString();
    
    virtual void hideAuxString();
    virtual void hideLookupTable();
    virtual void hidePreeditString();

protected:
    QVBoxLayout* inputWindowLayout;
    QHBoxLayout* bottomLineLayout;

protected slots:
    virtual void languageChange();
    virtual void changeSetting();

private:
    ModulesCollection* allModules;
    scim::SocketServerThread* InputServer;
//     KConfig* Config;
    bool LookupTableIsVertical, sticky;
    QRect ScreenRect;
//     QSpacerItem* BottomSpacer;
    int OriginalX, OriginalY;
};

#endif // INPUTWINDOW_H
