/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                          *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef SCIMLINEEDIT_H
#define SCIMLINEEDIT_H

#include "src/modulescollection.h"

#include "scimdragableframe.h"

/**
@author liuspider
*/
class ScimLineEditPrivate;
class ScimLineEdit : public ScimDragableFrame
{
Q_OBJECT
public:
    ScimLineEdit(QWidget *parent = 0, const char *name = 0);

    ~ScimLineEdit();
    QString text() const {return _text;};
    void setText(QString s);
    virtual void drawContents( QPainter *p );
    QSize minimumSizeHint() const;
    QSize minimumSize() const { return minimumSizeHint(); }
    QSize sizeHint() const { return minimumSize(); }
    void setTextFormat(scim::AttributeList);
    int cursorPosition();
public slots:
    virtual void setCursorPosition ( int );
private:
    int cursorPos;
    scim::AttributeList attribList;
    QString _text;
    ScimLineEditPrivate* d;
};

#endif
