/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                          *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "scimstringlistitem.h"

ScimStringListItem::ScimStringListItem(int _index, QWidget *parent, const char *name)
 : QLabel(parent, name), index(_index)
{
}
// void ScimStringListItem::setMouseTracking(bool b)
// {
//     enableHighlight = b;
//     QLabel::setMouseTracking(b);
// }
void ScimStringListItem::mousePressEvent(QMouseEvent *)
{
    emit(selected(index));
}
void ScimStringListItem::mouseMoveEvent( QMouseEvent * )
{
    setHighlight(true);
    emit(highlighted(index));
}
void ScimStringListItem::setHighlight(bool highlighted)
{
    static const QColorGroup& cg = colorGroup();
    if(highlighted)
    {
        setPaletteForegroundColor( cg.highlightedText() );
        setPaletteBackgroundColor( cg.highlight() );
    }
    else
    {
        setPaletteForegroundColor( cg.foreground() );
        setPaletteBackgroundColor( cg.background() );
    }
}
ScimStringListItem::~ScimStringListItem()
{
}


#include "scimstringlistitem.moc"
