/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                          *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#define USE_SCIM_KDE_SETTINGS
#include "src/modulescollection.h"
#include "configinputwindow.h"
#include <klocale.h>
#include <kfontdialog.h>

#define MODULE_UUID "a1d34730-6d08-4f59-a418-e63334a46538"
extern "C" {
    static ConfigInputWindow* _configinputwindow_widget = 0;
    QWidget* init( ModulesCollection* /*is*/, ModuleDefinition& md, QWidget* preferedParent)
    {
        if( md.uuid == MODULE_UUID )
        {
            _configinputwindow_widget = new ConfigInputWindow(preferedParent);
//             _setupwindow_widget->show();
            return _configinputwindow_widget;
        }
        return 0;
    }
    bool getInfo( ModulesCollection * , ModuleDefinition* md)
    {
        md->uuid = MODULE_UUID;
        md->type = scim_kde::ConfigModule;
        md->load_type = scim_kde::Temporary;
//         md->load_type = scim_kde::Temporary;
        md->name = i18n("Setup UI for Input Window");
        md->comment = "";

        return true;
    }
    bool isFinished()
    {
        return !_configinputwindow_widget;
    }
}

ConfigInputWindow::ConfigInputWindow(QWidget *parent, const char */*name*/)
 : ConfigInputWindowBase(parent),_changed(false)
{
    if(!ScimKdeSettings::iW_Font().isEmpty())
    {
      oldCustomFont.fromString(ScimKdeSettings::iW_Font());
      defaultFontChooser->setFont(oldCustomFont);
    }
    else
    {
      oldCustomFont = font();
      defaultFontChooser->setFont(font());
    }
    defaultFontChooser->setSampleText(i18n("The Quick Brown Fox Jumps Over The Lazy Dog"));
    connect(defaultFontChooser, SIGNAL(fontSelected (const QFont &)), SLOT(fontChanged (const QFont &)));
    SettingsDialog->addPage(this, i18n("Input Window"), "editclear");
}


ConfigInputWindow::~ConfigInputWindow()
{
    _configinputwindow_widget = 0;
}

bool ConfigInputWindow::hasChanged()
{
    return _changed;
}

void ConfigInputWindow::saveSettings()
{
    if(!hasChanged())
      return;
    oldCustomFont = defaultFontChooser->font();
    ScimKdeSettings::setIW_Font(oldCustomFont.toString());
    ScimKdeSettings::writeConfig();
    _changed = false;
}
void ConfigInputWindow::fontChanged (const QFont &f)
{
    if(f == oldCustomFont)
      _changed = false;
    else
      _changed = true;
    emit changed();
}
#include "configinputwindow.moc"
