/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                       *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "kdetraystatus.h"

#include <qpixmap.h>
#include <qiconset.h>
#include <kpopupmenu.h>
#include <kiconloader.h>

#include "config.h"
#include "src/scimglobalactions.h"

#define MODULE_UUID "664bde5f-76a8-4e18-9600-81c8a64fd2ad"
extern "C" {
    static KDETrayStatus* _kdetray_widget = 0;
    QWidget* init( ModulesCollection* is, ModuleDefinition& md, QWidget* /*preferedParent*/)
    {
        if( md.uuid == MODULE_UUID )
        {
          _kdetray_widget = new KDETrayStatus(is, 0, "KdeTrayStatus");
          _kdetray_widget->show();
          return _kdetray_widget;
        }
        return 0;
    }
    bool getInfo( ModulesCollection * , ModuleDefinition* md)
    {
        md->uuid = MODULE_UUID;
        md->type = scim_kde::GeneralModule;
        md->load_type = scim_kde::Permanent;
//         md->load_type = scim_kde::Temporary;
        md->name = i18n("System Tray");
        md->comment = i18n("A system tray indicator.");

        return true;
    }
    bool isFinished()
    {
        return !_kdetray_widget;
    }
}

KDETrayStatus::KDETrayStatus(ModulesCollection* ms, QWidget *parent, const char *name)
 : KSystemTray(parent, name)
{
    allModules = ms;
    #if !ENABLE_DEBUG
      actionCollection()->clear();  //clear default 'quit' and 'restore' action
    #endif
    contextMenu()->clear(); //get rid of default "title bar"
    KIconLoader *kil = KGlobal::iconLoader();
    setPixmap( kil->loadIcon("scim", KIcon::User) );
    #if ENABLE_DEBUG
    KAction* reloadAction = allModules->getActionCollection()->action( "reload" );
    if(reloadAction)
      reloadAction->plug(contextMenu());
      contextMenu()->insertSeparator();
    #endif

    KAction* config = allModules->getActionCollection()->action( "configure" );
    if(config)
      config->plug(contextMenu());
      
    KAction* aboutAppAction = allModules->getActionCollection()->action( "aboutapp" );
    if(aboutAppAction)
      aboutAppAction->plug(contextMenu());
          
    KAction* aboutKDEAction = allModules->getActionCollection()->action( "aboutkde" );
    if(aboutKDEAction)
      aboutKDEAction->plug(contextMenu());
    
//     contextMenu()->insertItem(QIconSet(QPixmap::fromMimeSource( "reload.png" )),"Reload All",
//         this, SLOT( requestReloadAllModules() ));
    connect( this, SIGNAL( quitSelected() ), allModules, SLOT( exitMain() ));
    connect( allModules->getInputServer(), SIGNAL(updateServerInfoReq(QString, QString)),
      this, SLOT(updateIcon(QString, QString )));
}

KDETrayStatus::~KDETrayStatus()
{
    _kdetray_widget = 0;
}
void KDETrayStatus::updateIcon(QString, QString icon)
{
    QPixmap newIcon(icon.ascii());
    QIconSet newIconSet( newIcon );
    setPixmap(newIconSet.pixmap(QIconSet::Automatic,QIconSet::Normal, QIconSet::On ));
}

