/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                       *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "src/modulescollection.h"
#include "utils/scimxmlguibuilder.h"
#include "scimdragableframe.h"

#include <kmainwindow.h>

// class ScimServerPopupMenu;
class ScimToolBar;
class ScimMoveHandle;

class QPopupMenu;
// class QToolButton;
class QHBoxLayout;

class MainWindow : public ScimDragableFrame, public ScimXMLGUIClient
{
    Q_OBJECT

public:
    MainWindow( ModulesCollection*, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~MainWindow();

    ScimMoveHandle* moveHandle;

public slots:
    virtual void show();
    virtual void hide();
    virtual void adjustSize();

private:

    ModulesCollection* allModules;
    scim::SocketServerThread* InputServer;

    QTimer* AutoHideTimeoutTimer;

    int AutoHideTimeout;
    bool PanelTurnedOn;
    bool AlwaysShow;
    bool autoSnap;

protected:
    QHBoxLayout* MainWindowLayout;
    QPoint clickPos;
    ScimToolBar* toolbar;
    ScimGlobalActions* defaultActionCollection;
    QPopupMenu* contextMenu;

protected slots:
    virtual void languageChange();
    virtual void contextMenuEvent ( QContextMenuEvent * );
};

#endif // MAINWINDOW_H
