/* This file is part of the KDE project
   Copyright (C) 2001 Christoph Cullmann <cullmann@kde.org>
   Copyright (C) 2002 Joseph Wenninger <jowenn@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef __CONFIGMODPLUGINWIDGET_H__
#define __CONFIGMODPLUGINWIDGET_H__

#define USE_SCIM_KDE_SETTINGS
#include "src/modulescollection.h"

#include "utils/configpluginwidget.h"
#include <klistview.h>

class ScimKDEPluginListItem; 

class ScimKDEPluginListView : public KListView
{
  Q_OBJECT
  
  friend class ScimKDEPluginListItem;
  
  public:
    ScimKDEPluginListView (QWidget *parent = 0, const char *name = 0);

  signals:
    void stateChange(ScimKDEPluginListItem *, bool);
  
  private:
    void stateChanged(ScimKDEPluginListItem *, bool);
};

class ScimConfigModulesWidget: public ScimConfigPluginWidget
{
  Q_OBJECT

  public:
    ScimConfigModulesWidget(ModulesCollection* is, QWidget *parent);
    ~ScimConfigModulesWidget(){;};
    virtual void saveSettings();
    virtual void updateWidgetsDefault();
    virtual bool isDefault();
    virtual bool hasChanged();
  public slots:
    virtual void show();
  private:
    class ModulesCollection* mPluginMan;
//     class ScimSetupWindow *SettingsDialog;
    ScimKDEPluginListView* listView;

//   signals:
//     void changed();

  private slots:
    void stateChange(ScimKDEPluginListItem *, bool);
/*    void loadPlugin (ScimKDEPluginListItem *);
    void unloadPlugin (ScimKDEPluginListItem *);*/
};

#endif
