/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                          *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#define USE_SCIM_KDE_SETTINGS
#include "src/modulescollection.h"
#include "scimsetupwindow.h"

#include "interface_setup.h"
#include "configmoduleswidget.h"
#include "src/scimglobalactions.h"

#include <klocale.h>
#define MODULE_UUID "508e2667-f354-414c-9f1b-eb0d56824528"
extern "C" {
    static ScimSetupWindow* _setupwindow_widget = 0;
    QWidget* init( ModulesCollection* is, ModuleDefinition& md, QWidget* /*preferedParent*/)
    {
        if( md.uuid == MODULE_UUID )
        {
// In order to use this dialog, it is not required to load this plugin at startup: the loading of this plugin is totally automatical and on-demand.
            _setupwindow_widget = new ScimSetupWindow(is, "All in one Setup UI", ScimKdeSettings::self());
//             _setupwindow_widget->show();
            return _setupwindow_widget;
        }
        return 0;
    }
    bool getInfo( ModulesCollection * , ModuleDefinition* md)
    {
        md->uuid = MODULE_UUID;
        md->type = scim_kde::GeneralModule;
        md->load_type = scim_kde::Temporary;
        md->name = i18n("Setup Dialog");
        md->comment = i18n("All settings for both SCIM and scim-panel-kde can be customized here.");

        return true;
    }
    bool isFinished()
    {
        return !_setupwindow_widget;
    }
}

ScimSetupWindow::ScimSetupWindow(QWidget *parent, const char *name, KConfigSkeleton *config)
 : ScimSetupWindowBase(parent, name, config, KDialogBase::IconList)
{
    mc = static_cast<ModulesCollection*>(parent);
//     addPage(new Interface(this, "Interface"), i18n("Interface"), "interface_settings");
    ScimConfigPluginWidget* cpWidget = new ScimConfigModulesWidget(mc, this);
    addPage(cpWidget, i18n("Plugins"), "input_devices_settings");
    connect(this, SIGNAL(aboutToShowPage(QWidget *)), this, SLOT(adjustSize()));
}
KActionCollection* ScimSetupWindow::actionCollection()
{
  return mc->getActionCollection();
}
ScimSetupWindow::~ScimSetupWindow()
{
  _setupwindow_widget = 0;
}
void ScimSetupWindow::addPage (QWidget *page, const QString &itemName, const QString &pixmapName, 
      const QString &header, bool manage)
{
    KConfigDialog::addPage(page, itemName, pixmapName, header, manage);
    SCIM_DEBUG_CONFIG(1) <<"added setup page " << itemName << "\n";
    if(ScimConfigPluginWidget* curpage = dynamic_cast<ScimConfigPluginWidget*>(page))
    {
      
      configWidgets.push_back(curpage);
      connect(curpage, SIGNAL(changed()), SLOT(updateButtons()));
    }
}
void ScimSetupWindow::show()
{
    
    static bool configModulesLoaded = false;
    //load all configmodules installed
    //TODO: unneeded ones will be hidden later
    if(configModulesLoaded)
    {
      KConfigDialog::show();
      return;
    }
      
    mc->loadModules(true, scim_kde::ConfigModule, this);
    configModulesLoaded = true;
    KConfigDialog::show();
}
//FIXME: unload config modules when hide and connect destroy signals
// void ScimSetupWindow::hide()
// {
//     KConfigDialog::hide();
// }
void ScimSetupWindow::updateSettings()
{
  bool emitSignal = true;
  if(KConfigDialog::hasChanged())
  {
    KConfigDialog::updateSettings();
    emitSignal = false;
  }
  for(uint i = 0; i < configWidgets.size(); i++)
    configWidgets[i]->saveSettings();
  if(emitSignal)
    emit settingsChanged();
}
// void ScimSetupWindow::updateWidgets ()
// {
//   KConfigDialog::updateWidgets();
//   KConfigDialog::updateButtons();
// }
void ScimSetupWindow::updateWidgetsDefault()
{
  KConfigDialog::updateWidgetsDefault();
  for(uint i = 0; i < configWidgets.size(); i++)
    configWidgets[i]->updateWidgetsDefault();
}

bool ScimSetupWindow::hasChanged()
{
  if(KConfigDialog::hasChanged())
    return true;
  else
    for(uint i = 0; i < configWidgets.size(); i++)
      if(configWidgets[i]->hasChanged())
        return true;
  return false;
//     return pluginConfigWidget->hasChanged();
}

bool ScimSetupWindow::isDefault()
{
  if(!KConfigDialog::isDefault())
    return false;
  else
    for(uint i = 0; i < configWidgets.size(); i++)
      if(!configWidgets[i]->isDefault())
        return false;
  return true;
//     return pluginConfigWidget->isDefault();
}
#include "scimsetupwindow.moc"
