/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                       *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "modulescollection.h"

#include "config.h"
#include <kapplication.h> 
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kglobal.h>
#include <config.h>
#include <dcopclient.h>  

static const char description[] =
    I18N_NOOP("KDE Frontend for SCIM Input Method Platform");

static KCmdLineOptions options[] =
{
    { "V", I18N_NOOP( "Document to open." ), 0 },
    { "d", I18N_NOOP( "Start as Damon" ), 0 },
    { "c <config module>", I18N_NOOP( "Use this specified config module (currently only one config module is available" ), 0 },  //FIXME
    KCmdLineLastOption
};

void make_daemon ()
{
    if (daemon (1, 1) == -1)
        std::cerr << "Error to make myself into a daemon!\n";

    return;
}

int main( int argc, char ** argv )
{    
// KGlobal::locale()->insertCatalogue( "scim_panel_kde_ui" );
//     KGlobal::locale()->setMainCatalogue(PACKAGE);
    KAboutData about(PACKAGE, PACKAGE, VERSION, description,
        KAboutData::License_GPL_V2, "(C) 2004 Cougar",
        "SCIM Mail List <scim@freedesktop.org>", 0, "liuspider@yahoo.com");
    about.addAuthor( "Cougar (liuspider)", 0, "liuspider@yahoo.com" );
    about.addCredit ( "James Su", I18N_NOOP("SCIM Primary Author"), "suzhe@tsinghua.org.cn" );
    QString curarg;
    scim::uint32 verbose_level = 0;

    for(int i = 1; i < argc ; i++)
    {
        curarg = argv[i];
        if( curarg == "-V" )
        {
            verbose_level++;
            continue;
        }
    }
    
    //noxim is necessary to disable xim support in qt for this app
    const char* fake_arg1 =  "--noxim";
    char* fake_argv[10] = {argv[0], const_cast<char *>(fake_arg1), 0, 0, 0, 0, 0};
    for(int i = 1; i < argc; i++)
    {
      fake_argv[i+1] = argv[i];
    }
    KCmdLineArgs::init(argc+1, fake_argv, &about);

    KCmdLineArgs::addCmdLineOptions( options );

    scim::DebugOutput::set_verbose_level( verbose_level );
    scim::DebugOutput::disable_debug (SCIM_DEBUG_AllMask);
    scim::DebugOutput::enable_debug (SCIM_DEBUG_FrontEndMask);

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

    if( args->isSet("d") )
        make_daemon ();

    KApplication * kAppMainThread = new KApplication();
//     DCOPClient* dcopClt = kAppMainThread->dcopClient();
//     dcopClient()->registerAs(KCmdLineArgs::about->appName(), false );
//     new ModulesCollection(about);
//     ModulesCollection* allModules = new ModulesCollection(about);
//     allModules->loadAllModules();
    kAppMainThread->setMainWidget( new ModulesCollection(about) );
//     allModules->loadModule( InputWindowModule );
//     allModules->loadModule( KDESysTray );
    return kAppMainThread->exec();
}
