/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                          *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef SCIMGLOBALACTIONS_H
#define SCIMGLOBALACTIONS_H

#include <kactioncollection.h>
#include <kaboutapplication.h>
#include <kaboutdata.h>

#include "scimhelpdialog.h"
/**
@author spider
*/
class ModulesCollection;
class ScimAction;
class ScimComboAction;

class ScimGlobalActions : public KActionCollection
{
Q_OBJECT
public:
    ScimGlobalActions(QWidget *parent = 0, const char *name = 0);

    ~ScimGlobalActions();
    
protected slots:
    //action slots
//     void aboutKDE();
    void aboutApp();
    void showHelp( QString );
    
    void toggleStick();
    void UpdatePunctuation( bool );
    void UpdateLetterWidth( bool );
    
    void SetServerInfo( QString, QString );
    void changeServer();
    void receiveServerMenu(std::vector <QString> , std::vector <QString>, std::vector <QString>);
    void UpdateLangAction( QString s, scim::AttributeList );
    void requestReloadAllModules();
    void changeSetting();
//     void configure();

protected:
    ModulesCollection* mc;
    
    KToggleAction *StickAction;
    KToggleAction* LetterWidthAction;
    KToggleAction* PuctuateAction;
    ScimComboAction* ServerAction;
    ScimAction* LangAction;
    
    KIconLoader *kil;
    
//     KAboutKDE* mAboutKDE;
    KAboutApplication* mAboutApp;
    ScimHelpDialog* helpDialog;
    
private:
    std::vector<QString> uuids;
    typedef std::pair<QPixmap*, QIconSet*> pixResType;
    std::vector<pixResType > pixResources;
    scim::SocketServerThread* InputServer;
    class KHelpMenu* mHelpMenu;
//     friend class ModulesCollection;
};

#endif
