/* This file is part of the KDE project
   Copyright (C) 2001 Christoph Cullmann <cullmann@kde.org>
   Copyright (C) 2002 Joseph Wenninger <jowenn@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef __CONFIGPLUGINWIDGET_H__
#define __CONFIGPLUGINWIDGET_H__

//#define USE_SCIM_KDE_SETTINGS
//#include "src/modulescollection.h"

#include <kconfigdialog.h>
#include <kactioncollection.h>
class ScimSetupWindowBase : public KConfigDialog
{
  Q_OBJECT
  public:
    ScimSetupWindowBase(QWidget *parent = 0, const char *name = 0, 
          KConfigSkeleton *config = 0, KDialogBase::DialogType type = KDialogBase::TreeList);
    ~ScimSetupWindowBase();
    virtual void addPage (QWidget *page, const QString &itemName, const QString &pixmapName, 
      const QString &header=QString::null, bool manage=true) = 0;
    virtual KActionCollection* actionCollection() = 0;
};

class KEditToolbarWidget;
class ScimConfigPluginWidget: public QWidget
{
  Q_OBJECT

  public:
    ScimConfigPluginWidget(QWidget *parent, const char *name = 0);
    //FIXME: make these pure virtual
    virtual ~ScimConfigPluginWidget(){;};
    virtual void saveSettings(){;};
    virtual void updateWidgetsDefault(){;};
    virtual bool isDefault() {return true;};
    virtual bool hasChanged() {return false;};

  protected:
    class ScimSetupWindowBase *SettingsDialog;
    KEditToolbarWidget* ediToolbar;

  signals:
    void changed();
};

#endif
