/***************************************************************************
 *   Copyright (C) 2003 by liuspider                                          *
 *   sharecash@163.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef SCIMACTIONS_H
#define SCIMACTIONS_H

#include <kaction.h>
namespace scim_kde{
  enum ScimActionPlugOption{
    ToolBarIconOnly = 1 << 1,
    ToolBarIconUseText = 1 << 2,
    ToolBarTextOnly = 1 << 3,
  };
};
class ScimAction : public KAction
{
Q_OBJECT
public:
    ScimAction(const QString &text, const QIconSet &pix, const KShortcut &cut, const QObject *receiver, const char *slot, KActionCollection *parent, const char *name);
    ScimAction (const QString &text, const KShortcut &cut, const QObject *receiver, const char *slot, KActionCollection *parent, const char *name);
    ~ScimAction();
    virtual int plug (QWidget *widget, int index=-1);
    virtual void setOption(scim_kde::ScimActionPlugOption op){option = op;};
    virtual void setDisplayedText( QString &);
    virtual void setCurrentIconSet(QIconSet &);
protected slots:
//     virtual void setText (const QString &text);
    //These functions are used to honor QToolButton's individual configurable TextIcon Mode.
    virtual void updateDText (int i);
    virtual void updateCIconSet( int id );
protected:
    scim_kde::ScimActionPlugOption option;
    QString displayText;
    QIconSet curIconset;
};
// plug into toolbar QComboBox, while pluging into popupmenu QMenu
#include <qmenudata.h>
class ScimComboAction : public ScimAction
{
Q_OBJECT
public:
    ScimComboAction (const QString &text, const QIconSet &pix, const KShortcut &cut, const QObject *receiver, const char *slot, KActionCollection *parent, const char *name);
    ScimComboAction (const QString &text, const KShortcut &cut, const QObject *receiver, const char *slot, KActionCollection *parent, const char *name);
    ~ScimComboAction();
    virtual int plug (QWidget *widget, int index=-1);
    int current(){return currentItemIndex;};
    int count(){ return data.count(); };
//     void setOption(scim_kde::ScimActionPlugOption op){option = op;};
public slots:
//     void slotActivated(int index);
//     void insertItem ( const QString & t, int index = -1 );
//     void insertItem ( const QPixmap & pixmap, int index = -1 );
    void setCurrent( int c);
//     void insertItem ( const QPixmap & pixmap, const QString & text, int index = -1 );
    void insertItem ( const QIconSet & icon, const QString & text, int id = -1);
//     void changeItem ( const QString & t, int index );
//     void changeItem ( const QPixmap & im, int index );
    void changeItem ( const QPixmap & im, const QString & t, int index );
    QString text ( int index ) const;
    const QIconSet* iconSet(int) const;
//     const QPixmap * pixmap ( int index ) const;
    void clear();
// protected slots:
//     void slotActivated( int index );
protected:
    void updateData(const QIconSet & icon, const QString & t, int index);
private:
    QMenuData data;
    int currentItemIndex;
};
#endif
